report 72102 SalesInvoiceDCR
{
    Caption = 'Sales - Invoice';
    Permissions = TableData "Sales Shipment Buffer" = rimd;
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(InvHdr; "Sales Invoice Header")
        {
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.", "Sell-to Customer No.", "No. Printed";
            RequestFilterHeading = 'Posted Sales Invoice';

            column(lblAllowInvDisc; Trl('AllowInvDisc')) { }
            column(lblAmount; Trl('Amount')) { }
            column(lblAmountInclVAT; Trl('AmountInclVAT')) { }
            column(lblAttachedToLineNo; Trl('AttachedToLineNo')) { }
            column(lblBankAccNo; Trl('BankAccNo')) { }
            column(lblBankBranchNo; Trl('BankBranchNo')) { }
            column(lblBankName; Trl('BankName')) { }
            column(lblBillToAddress; Trl('BillToAddress')) { }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo')) { }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo')) { }
            column(lblCrossReferenceNo; Trl('CrossReferenceNo')) { }
            column(lblDescription; Trl('Description')) { }
            column(lblDocumentDate; Trl('DocumentDate')) { }
            column(lblDocumentNo; Trl('DocumentNo')) { }
            column(lblDueDate; Trl('DueDate')) { }
            column(lblEmail; Trl('Email')) { }
            column(lblExternalDocumentNo; Trl('ExternalDocumentNo')) { }
            column(lblFaxNo; Trl('FaxNo')) { }
            column(lblFreeText1; Trl('FreeText1')) { }
            column(lblFreeText2; Trl('FreeText2')) { }
            column(lblFreeText3; Trl('FreeText3')) { }
            column(lblFreeText4; Trl('FreeText4')) { }
            column(lblGiroNo; Trl('GiroNo')) { }
            column(lblGLAccountNo; Trl('GLAccountNo')) { }
            column(lblGrossWeight; Trl('GrossWeight')) { }
            column(lblHeaderDimensions; Trl('HeaderDimensions')) { }
            column(lblHomePage; Trl('HomePage')) { }
            column(lblIBAN; Trl('IBAN')) { }
            column(lblInvDiscAmount; Trl('InvDiscAmount')) { }
            column(lblInvDiscBaseAmount; Trl('InvDiscBaseAmount')) { }
            column(lblInvoiceDate; Trl('InvoiceDate')) { }
            column(lblInvoiceNo; Trl('InvoiceNo')) { }
            column(lblLineAmount; Trl('LineAmount')) { }
            column(lblLineDimensions; Trl('LineDimensions')) { }
            column(lblLineDiscountAmount; Trl('LineDiscountAmount')) { }
            column(lblLineDiscountPerc; Trl('LineDiscountPerc')) { }
            column(lblLineNo; Trl('LineNo')) { }
            column(lblLocationCode; Trl('LocationCode')) { }
            column(lblLotNo; Trl('LotNo')) { }
            column(lblNetWeight; Trl('NetWeight')) { }
            column(lblNo; Trl('No')) { }
            column(lblOrderDate; Trl('OrderDate')) { }
            column(lblOrderNo; Trl('OrderNo')) { }
            column(lblPageOf; Trl('Page{0}of{1}')) { }
            column(lblPaymentDiscountVAT; Trl('PaymentDiscountVAT')) { }
            column(lblPaymentMethod; Trl('PaymentMethod')) { }
            column(lblPaymentTerms; Trl('PaymentTerms')) { }
            column(lblPhoneNo; Trl('PhoneNo')) { }
            column(lblPostingDate; Trl('PostingDate')) { }
            column(lblPrepaymentPaymentTerms; Trl('PrepaymentPaymentTerms')) { }
            column(lblPrepaymentSpecification; Trl('PrepaymentSpecification')) { }
            column(lblPrepaymentVATSpecification; Trl('PrepaymentVATSpecification')) { }
            column(lblPricesInclVAT; Trl('PricesInclVAT')) { }
            column(lblQtyInvoicedBase; Trl('QtyInvoicedBase')) { }
            column(lblQtyPerUOM; Trl('QtyPerUOM')) { }
            column(lblQtyToInvoiceBase; Trl('QtyToInvoiceBase')) { }
            column(lblQuantity; Trl('Quantity')) { }
            column(lblQuantityBase; Trl('QuantityBase')) { }
            column(lblQuantityInvoiced; Trl('QuantityInvoiced')) { }
            column(lblSalesPerson; Trl('SalesPerson')) { }
            column(lblSellToCustomerNo; Trl('SellToCustomerNo')) { }
            column(lblSerialNo; Trl('SerialNo')) { }
            column(lblShipment; Trl('Shipment')) { }
            column(lblShipmentDate; Trl('ShipmentDate')) { }
            column(lblShipmentMethod; Trl('ShipmentMethod')) { }
            column(lblShippingAgent; Trl('ShippingAgent')) { }
            column(lblShipToAddress; Trl('ShipToAddress')) { }
            column(lblSubtotal; Trl('Subtotal')) { }
            column(lblSWIFT; Trl('SWIFT')) { }
            column(lblTotal; Trl('Total')) { }
            column(lblTotalTransFooter; Trl('TotalTransFooter')) { }
            column(lblTotalTransHeader; Trl('TotalTransHeader')) { }
            column(lblType; Trl('Type')) { }
            column(lblUnitCost; Trl('UnitCost')) { }
            column(lblUnitCostLCY; Trl('UnitCostLCY')) { }
            column(lblUnitsPerParcel; Trl('UnitsPerParcel')) { }
            column(lblUnitPrice; Trl('UnitPrice')) { }
            column(lblUOM; Trl('UOM')) { }
            column(lblVATAmount; Trl('VATAmount')) { }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification')) { }
            column(lblVATBase; Trl('VATBase')) { }
            column(lblVATClause; Trl('VATClause')) { }
            column(lblVATIdentifier; Trl('VATIdentifier')) { }
            column(lblVATPerc; Trl('VATPerc')) { }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo')) { }
            column(lblYourReference; Trl('YourReference')) { }
            column(lblWorkDescription; Trl('WorkDescription')) { }

            column(BilltoCustNo; "Bill-to Customer No.") { }
            column(CompanyAddr1; wgCompanyAddr[1]) { }
            column(CompanyAddr2; wgCompanyAddr[2]) { }
            column(CompanyAddr3; wgCompanyAddr[3]) { }
            column(CompanyAddr4; wgCompanyAddr[4]) { }
            column(CompanyAddr5; wgCompanyAddr[5]) { }
            column(CompanyAddr6; wgCompanyAddr[6]) { }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.") { }
            column(CompanyBankBranchNo; wgRecCompanyInfo."Bank Branch No.") { }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name") { }
            column(CompanyCity; wgRecCompanyInfo.City) { }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail") { }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.") { }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.") { }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page") { }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN) { }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.") { }
            column(CompanyPicture; wgRecCompanyInfo.Picture) { }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.") { }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code") { }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.") { }
            column(CustAddr1; wgCustAddr[1]) { }
            column(CustAddr2; wgCustAddr[2]) { }
            column(CustAddr3; wgCustAddr[3]) { }
            column(CustAddr4; wgCustAddr[4]) { }
            column(CustAddr5; wgCustAddr[5]) { }
            column(CustAddr6; wgCustAddr[6]) { }
            column(CustAddr7; wgCustAddr[7]) { }
            column(CustAddr8; wgCustAddr[8]) { }
            column(DocumentDate; "Document Date") { }
            column(DocumentDateText; Format("Document Date", 0, 4)) { }
            column(DocumentNo; "No.") { }
            column(DueDate; "Due Date") { }
            column(DueDateText; Format("Due Date", 0, 4)) { }
            column(ExternalDocumentNo; "External Document No.") { }
            column(HideLineDiscount; wgHideLineDiscount) { }
            column(LanguageCode; "Language Code") { }
            column(LocationCity; wgRecLocation.City) { }
            column(LocationCode; "Location Code") { }
            column(LocationName; wgRecLocation.Name) { }
            column(OrderNo; "Order No.") { }
            column(PaymentMethodDesc; wgRecPaymentMethod.Description) { }
            column(PaymentTermsDesc; wgRecPaymentTerms.Description) { }
            column(PostingDate; "Posting Date") { }
            column(PostingDateText; Format("Posting Date", 0, 4)) { }
            column(PricesInclVAT; "Prices Including VAT") { }
            column(PricesInclVATYesNo; Format("Prices Including VAT")) { }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name) { }
            column(SelltoCustNo; "Sell-to Customer No.") { }
            column(SelltoPhoneNo; "Sell-to Phone No.") { }
            column(ShippingAgentCode; "Shipping Agent Code") { }
            column(ShippingAgentName; wgRecShippingAgent.Name) { }
            column(ShipmentMethodDesc; wgRecShipmentMethod.Description) { }
            column(ShipToAddr1; wgShipToAddr[1]) { }
            column(ShipToAddr2; wgShipToAddr[2]) { }
            column(ShipToAddr3; wgShipToAddr[3]) { }
            column(ShipToAddr4; wgShipToAddr[4]) { }
            column(ShipToAddr5; wgShipToAddr[5]) { }
            column(ShipToAddr6; wgShipToAddr[6]) { }
            column(ShipToAddr7; wgShipToAddr[7]) { }
            column(ShipToAddr8; wgShipToAddr[8]) { }
            column(ShipToAddrSet; wgShowShippingAddr) { }
            column(TodayText; Format(Today(), 0, 4)) { }
            column(TotalText; wgTotalText) { }
            column(TotalExclVATText; wgTotalExclVATText) { }
            column(TotalInclVATText; wgTotalInclVATText) { }
            column(VALExchRate; wgVALExchRate) { }
            column(VALSpecLCYHeader; wgVALSpecLCYHeader) { }
            column(VATBaseDiscPerc; "VAT Base Discount %")
            {
                AutoFormatType = 1;
            }
            column(VATRegNo; "VAT Registration No.") { }
            column(YourReference; "Your Reference") { }
            column(WorkDescription; "Work Description") { }

            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);

                column(OutputNo; wgOutputNo) { }
                column(SalesInvoiceTitle; StrSubstNo(wlFncDocumentCaption(), wgCopyText)) { }

                dataitem(HdrComment; "Sales Comment Line")
                {
                    DataItemLink = "No." = Field("No.");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const("Posted Invoice"), "Document Line No." = const(0));

                    column(Comment_2; Comment) { }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                    column(DimText; wgDimText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(InvLine; "Sales Invoice Line")
                {
                    DataItemTableView = sorting("Document No.", "Line No.");
                    UseTemporary = true;

                    column(Amount; Amount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AmountInclVAT; "Amount Including VAT")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AttachedToLineNo; "Attached to Line No.") { }
                    column(CrossReferenceNo; "Cross-Reference No.") { }
                    column(Description; Description) { }
                    column(Description2_2; "Description 2") { }
                    column(GrossWeight; "Gross Weight") { }
                    column(InvDiscAmount; -"Inv. Discount Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount; "Line Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineDiscAmount; "Line Discount Amount") { }
                    column(LineDiscPerc; "Line Discount %") { }
                    column(NetWeight; "Net Weight") { }
                    column(No_2; "No.") { }
                    column(PostedShipmentDate; wgPostedShipmentDate) { }
                    column(QtyPerUOM; "Qty. per Unit of Measure") { }
                    column(Quantity; Quantity) { }
                    column(QuantityBase; "Quantity (Base)") { }
                    column(Type; Format(Type)) { }
                    column(TypeNo; Type + 0) { }
                    column(UnitCost; "Unit Cost") { }
                    column(UnitCostLCY; "Unit Cost (LCY)") { }
                    column(UnitPrice; "Unit Price")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 2;
                    }
                    column(UnitsPerParcel; "Units per Parcel") { }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }
                    column(UOMCode; "Unit of Measure Code") { }
                    column(VATIdentifier; "VAT Identifier") { }

                    dataitem(LineComment; "Sales Comment Line")
                    {
                        DataItemLink = "No." = Field("Document No."), "Document Line No." = Field("Line No.");
                        DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const("Posted Invoice"));

                        column(Comment; Comment) { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(ShipmentBuf; "Sales Shipment Buffer")
                    {
                        DataItemTableView = sorting("Document No.", "Line No.", "Entry No.");
                        UseTemporary = true;

                        column(Quantity_5; Quantity) { }
                        column(PostingDate_2; "Posting Date") { }

                        trigger OnPreDataItem()
                        begin
                            Reset();
                            SetRange("Document No.", InvLine."Document No.");
                            SetRange("Line No.", InvLine."Line No.");
                        end;
                    }
                    dataitem(LineDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                        column(DimText_2; wgDimText) { }

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(AsmLine; "Posted Assembly Line")
                    {
                        DataItemTableView = sorting("Document No.", "Line No.");
                        UseTemporary = true;

                        column(Description_3; Description) { }
                        column(LineNo_2; "No.") { }
                        column(Quantity_3; Quantity)
                        {
                            DecimalPlaces = 0 : 5;
                        }
                        column(UOM_2; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }
                        column(VariantCode; "Variant Code") { }

                        trigger OnPreDataItem()
                        begin
                            Reset();
                        end;
                    }
                    dataitem(TrackingSpec; "Tracking Specification")
                    {
                        DataItemTableView = sorting("Entry No.");
                        UseTemporary = true;

                        column(LotNo; "Lot No.") { }
                        column(SerialNo; "Serial No.") { }
                        column(Quantity_4; "Quantity (Base)") { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowLotSN then
                                CurrReport.Break();

                            Reset();
                            SetRange("Source Ref. No.", InvLine."Line No.");
                        end;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        //Get Shipment Lines
                        wgPostedShipmentDate := 0D;
                        if InvLine.Quantity <> 0 then
                            wgPostedShipmentDate := wlFncFindPostedShipmentDate(InvLine);

                        if wgDisplayAssemblyInformation then
                            wlFncCollectAsmInformation(InvLine, AsmLine);

                        if not InvHdr."Prices Including VAT" and
                           (InvLine."VAT Calculation Type" = InvLine."VAT Calculation Type"::"Full VAT")
                        then
                            InvLine."Line Amount" := 0;

                        if (InvLine.Type = InvLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                            InvLine."No." := '';
                    end;

                    trigger OnPreDataItem()
                    var
                        wlMoreLines: Boolean;
                    begin
                        Reset();
                        wlMoreLines := InvLine.Find('+');
                        while wlMoreLines and (InvLine.Description = '') and (InvLine."Description 2" = '') and
                              (InvLine."No." = '') and (InvLine.Quantity = 0) and
                              (InvLine.Amount = 0)
                        do
                            wlMoreLines := InvLine.Next(-1) <> 0;
                        if not wlMoreLines then
                            CurrReport.Break();
                        InvLine.SetRange("Line No.", 0, InvLine."Line No.");
                    end;
                }
                dataitem(VATAmtLine; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(InvDiscAmount_2; "Invoice Discount Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(InvDiscBaseAmount; "Inv. Disc. Base Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount_2; "Line Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmount; "VAT Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATBase; "VAT Base")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_2; "VAT Identifier") { }
                    column(VATPerc; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if wgTotVATAmount = 0 then
                            CurrReport.Break();

                        Reset();
                    end;
                }
                dataitem(VATClause; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(Description_4; wgRecVATClause.Description) { }
                    column(Description2; wgRecVATClause."Description 2") { }
                    column(VATAmount_4; "VAT Amount") { }
                    column(VATClauseCode; "VAT Clause Code") { }
                    column(VATIdentifier_4; "VAT Identifier") { }

                    trigger OnAfterGetRecord()
                    begin
                        if "VAT Clause Code" = '' then
                            CurrReport.Skip();
                        if wgRecVATClause.Code <> "VAT Clause Code" then
                            if not wgRecVATClause.Get("VAT Clause Code") then
                                CurrReport.Skip();

                        wgRecVATClause.TranslateDescription(InvHdr."Language Code");
                    end;

                    trigger OnPreDataItem()
                    begin
                        Copy(VATAmtLine, true); //Set VATClause to VATAmtLine
                        Reset();
                    end;
                }
                dataitem(VATAmtLineLCY; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(VALVATBaseLCY; wgVALVATBaseLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VALVATAmountLCY; wgVALVATAmountLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_3; "VAT Identifier") { }
                    column(VATPerc_2; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        wgVALVATBaseLCY :=
                          VATAmtLine.GetBaseLCY(
                            InvHdr."Posting Date", InvHdr."Currency Code", InvHdr."Currency Factor");
                        wgVALVATAmountLCY :=
                          VATAmtLine.GetAmountLCY(
                            InvHdr."Posting Date", InvHdr."Currency Code", InvHdr."Currency Factor");

                        wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                        wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowVATLCY then
                            CurrReport.Break();

                        Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                        Reset();
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));

                    column(MonolithicVAT; wgMonolithicVAT) { }
                    column(NoOfVATAmtLines; wgNoOfVATAmountLines) { }
                    column(TotAmount; wgTotAmount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotInvDiscAmount; wgTotInvDiscAmount) { }
                    column(TotInvDiscBaseAmount; wgTotInvDiscBaseAmount) { }
                    column(TotLineAmount; wgTotLineAmount) { }
                    column(TotPaymentDiscOnVAT; wgTotPaymentDiscOnVAT)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotVATAmount; wgTotVATAmount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmtText; wgVATAmountText) { }
                    column(TotVALVATBaseLCY; wgTotVALVATBaseLCY) { }
                    column(TotVALVATAmountLCY; wgTotVALVATAmountLCY) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgNoOfVATAmountLines := VATAmtLine.Count();
                        wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                        if wgMonolithicVAT then
                            wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, 30)
                        else
                            wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, 30);
                    end;
                }
                dataitem(PayRepArgument; "Payment Reporting Argument")
                {
                    DataItemTableView = sorting(Key);
                    UseTemporary = true;

                    column(PaymentServiceLogo; Logo) { }
                    column(PaymentServiceURLText; "URL Caption") { }
                    column(PaymentServiceURL; GetTargetURL()) { }

                    trigger OnPreDataItem()
                    var
                        wlRecPayServSetup: Record "Payment Service Setup";
                    begin
                        wlRecPayServSetup.CreateReportingArgs(PayRepArgument, InvHdr);
                        if IsEmpty() then
                            CurrReport.Break();
                    end;
                }
                dataitem(LineFee; "Line Fee Note on Report Hist.")
                {
                    DataItemTableView = sorting("Cust. Ledger Entry No", "Due Date", "Language Code", "Reminder Terms Code", "Reminder Level No");
                    UseTemporary = true;

                    column(ReportText; ReportText) { }

                    trigger OnAfterGetRecord()
                    begin
                        if not wgDisplayAdditionalFeeNote then
                            CurrReport.Break();
                    end;
                }

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, 30);
                        wgOutputNo += 1;
                    end;

                    wgTotVALVATBaseLCY := 0;
                    wgTotVALVATAmountLCY := 0;
                end;

                trigger OnPostDataItem()
                begin
                    if not CurrReport.Preview() then
                        Codeunit.Run(Codeunit::"Sales Inv.-Printed", InvHdr);
                end;

                trigger OnPreDataItem()
                var
                    wlRecCust: Record Customer;
                begin
                    if not wlRecCust.Get(InvHdr."Bill-to Customer No.") then
                        Clear(wlRecCust);
                    wgNoOfLoops := Abs(wgNoOfCopies) + wlRecCust."Invoice Copies" + 1;

                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlRecRef: RecordRef;
            begin
                CurrReport.Language := wgCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncFormatAddressFields(InvHdr);
                wlFncFormatDocumentFields(InvHdr);
                wlFncGetLineFeeNoteOnReportHist("No.");

                if wgLogInteraction then
                    if not CurrReport.Preview() then
                        if "Bill-to Contact No." <> '' then
                            wgCduSegManagement.LogDocument(
                              4, "No.", 0, 0, Database::Contact, "Bill-to Contact No.", "Salesperson Code",
                              "Campaign No.", "Posting Description", '')
                        else
                            wgCduSegManagement.LogDocument(
                              4, "No.", 0, 0, Database::Customer, "Bill-to Customer No.", "Salesperson Code",
                              "Campaign No.", "Posting Description", '');

                //Get Invoice Lines
                InvLine.Reset();
                InvLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlFncGetSalesInvoiceLines(InvHdr, InvLine);

                //Get VAT Amount Lines
                InvLine.CalcVATAmountLines(InvHdr, VATAmtLine);
                wgTotInvDiscAmount := VATAmtLine.GetTotalInvDiscAmount();
                wgTotInvDiscBaseAmount := VATAmtLine.GetTotalInvDiscBaseAmount(InvHdr."Prices Including VAT", InvHdr."Currency Code");
                wgTotLineAmount := VATAmtLine.GetTotalLineAmount(InvHdr."Prices Including VAT", InvHdr."Currency Code");
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotPaymentDiscOnVAT := -(wgTotLineAmount - wgTotInvDiscAmount - VATAmtLine.GetTotalAmountInclVAT());
                wgTotAmount := VATAmtLine.GetTotalVATBase();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                   (InvHdr."Currency Code" = '') or
                   (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(InvHdr."Posting Date", InvHdr."Currency Code", 1);
                    wgVALExchRate := CopyStr(StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount"), 1, 50);
                end;

                //Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();
                if wgShowLotSN then begin
                    wgCduItemTrackingDocMgt.SetRetrieveAsmItemTracking(true);
                    wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, InvHdr."No.",
                        Database::"Sales Invoice Header", 0);
                end;

                //Set HideLineDiscount
                wlRecRef.GetTable(InvHdr);
                wgHideLineDiscount := wgCduwDCR_ReportFunctions.wgFncHideLineDiscount(wlRecRef);

                if not wgRecLocation.Get("Location Code") then
                    Clear(wgRecLocation);

                if not wgRecShippingAgent.Get("Shipping Agent Code") then
                    Clear(wgRecShippingAgent);
            end;
        }
    }

    requestpage
    {
        SaveValues = true;

        layout
        {
            area(content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnable;
                    }
                    field(ShowAssemblyComponents; wgDisplayAssemblyInformation)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Assembly Components';
                    }
                    field(DisplayAdditionalFeeNote; wgDisplayAdditionalFeeNote)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Additional Fee Note';
                        ToolTip = 'Specifies that any notes about additional fees are included on the document.';
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnable := true;
        end;

        trigger OnOpenPage()
        begin
            InitLogInteraction();
            wgLogInteractionEnable := wgLogInteraction;

            wgNoOfCopies := 0;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecSalesSetup.Get();

        wgRecCompanyInfo.Get();
        wgRecCompanyInfo.VerifyAndSetPaymentInfo();

        if wgRecSalesSetup."Logo Position on Documents" <> wgRecSalesSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        if not CurrReport.UseRequestPage() then begin
            InitLogInteraction();
            wgNoOfCopies := 0;
        end;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecLocation: Record Location;
        wgRecPaymentMethod: Record "Payment Method";
        wgRecPaymentTerms: Record "Payment Terms";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecSalesSetup: Record "Sales & Receivables Setup";
        wgRecShipmentMethod: Record "Shipment Method";
        wgRecShippingAgent: Record "Shipping Agent";
        wgRecVATClause: Record "VAT Clause";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduFormatDoc: Codeunit "Format Document";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduLanguage: Codeunit Language;
        wgCduSegManagement: Codeunit SegManagement;
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgPostedShipmentDate: Date;
        wgCompanyAddr: array[8] of Text[100];
        wgCompanyInfoFaxNo: Text;
        wgCompanyInfoPhoneNo: Text;
        wgCopyText: Text[30];
        wgCustAddr: array[8] of Text[100];
        wgDimText: Text[120];
        wgShipToAddr: array[8] of Text[100];
        wgTotalExclVATText: Text[50];
        wgTotalInclVATText: Text[50];
        wgTotalText: Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgVATAmountText: Text[30];
        wgTotAmount: Decimal;
        wgTotInvDiscAmount: Decimal;
        wgTotInvDiscBaseAmount: Decimal;
        wgTotLineAmount: Decimal;
        wgTotPaymentDiscOnVAT: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgFirstValueEntryNo: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgNoOfVATAmountLines: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgShipmentLineNextEntryNo: Integer;
        wgDisplayAdditionalFeeNote: Boolean;
        wgDisplayAssemblyInformation: Boolean;
        wgHideLineDiscount: Boolean;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnable: Boolean;
        wgMonolithicVAT: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgShowShippingAddr: Boolean;
        wgShowVATLCY: Boolean;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        if wgReportId = 0 then begin
            Evaluate(wgReportId, DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890')));
            wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        end;
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    procedure InitializeRequest(pNewNoOfCopies: Integer; pNewShowInternalInfo: Boolean; pNewLogInteraction: Boolean; pNewDisplayAsmInfo: Boolean)
    begin
        wgNoOfCopies := pNewNoOfCopies;
        wgShowInternalInfo := pNewShowInternalInfo;
        wgLogInteraction := pNewLogInteraction;
        wgDisplayAssemblyInformation := pNewDisplayAsmInfo;
    end;

    procedure InitLogInteraction()
    begin
        wgLogInteraction := wgCduSegManagement.FindInteractTmplCode(4) <> '';
    end;

    local procedure wlFncDocumentCaption(): Text[250]
    begin
        if InvHdr."Prepayment Invoice" then
            exit(CopyStr(Trl('SalesPrepaymentInvoice%1'), 1, 250));
        exit(CopyStr(Trl('SalesInvoice%1'), 1, 250));
    end;

    local procedure wlFncGetSalesInvoiceLines(var vRecSalesInvHeader: Record "Sales Invoice Header"; var vRecSalesInvLine: Record "Sales Invoice Line")
    var
        wlRecSalesInvLine: Record "Sales Invoice Line";
    begin
        wlRecSalesInvLine.SetRange("Document No.", vRecSalesInvHeader."No.");
        if wlRecSalesInvLine.FindSet() then
            repeat
                vRecSalesInvLine := wlRecSalesInvLine;
                vRecSalesInvLine.Insert();
            until wlRecSalesInvLine.Next() = 0;
    end;

    local procedure wlFncCollectAsmInformation(var vRecSalesInvLine: Record "Sales Invoice Line"; var vRecPostedAsmLine: Record "Posted Assembly Line")
    var
        wlRecItemLedgerEntry: Record "Item Ledger Entry";
        wlRecSalesShipmentLine: Record "Sales Shipment Line";
        wlRecPostedAsmHeader: Record "Posted Assembly Header";
        wlRecPostedAsmLine: Record "Posted Assembly Line";
        wlRecValueEntry: Record "Value Entry";
    begin
        //According CollectAsmInformation Report 206
        //Needed for AsmLine
        vRecPostedAsmLine.DeleteAll();
        if vRecSalesInvLine.Type <> vRecSalesInvLine.Type::Item then
            exit;
        with wlRecValueEntry do begin
            SetCurrentKey("Document No.");
            SetRange("Document No.", vRecSalesInvLine."Document No.");
            SetRange("Document Type", "Document Type"::"Sales Invoice");
            SetRange("Document Line No.", vRecSalesInvLine."Line No.");
            SetRange(Adjustment, false);
            if not FindSet() then
                exit;
        end;
        repeat
            if wlRecItemLedgerEntry.Get(wlRecValueEntry."Item Ledger Entry No.") then
                if wlRecItemLedgerEntry."Document Type" = wlRecItemLedgerEntry."Document Type"::"Sales Shipment" then begin
                    wlRecSalesShipmentLine.Get(wlRecItemLedgerEntry."Document No.", wlRecItemLedgerEntry."Document Line No.");
                    if wlRecSalesShipmentLine.AsmToShipmentExists(wlRecPostedAsmHeader) then begin
                        wlRecPostedAsmLine.SetRange("Document No.", wlRecPostedAsmHeader."No.");
                        if wlRecPostedAsmLine.FindSet() then
                            repeat
                                wlFncTreatAsmLineBuffer(wlRecPostedAsmLine, vRecPostedAsmLine);
                            until wlRecPostedAsmLine.Next() = 0;
                    end;
                end;
        until wlRecValueEntry.Next() = 0;
    end;

    local procedure wlFncTreatAsmLineBuffer(var vRecPostedAsmLine: Record "Posted Assembly Line"; var vRecPostedAsmLineBuffer: Record "Posted Assembly Line")
    begin
        //According TreatAsmLineBuffer Report 206
        //Needed for AsmLine
        Clear(vRecPostedAsmLineBuffer);
        vRecPostedAsmLineBuffer.SetRange(Type, vRecPostedAsmLine.Type);
        vRecPostedAsmLineBuffer.SetRange("No.", vRecPostedAsmLine."No.");
        vRecPostedAsmLineBuffer.SetRange("Variant Code", vRecPostedAsmLine."Variant Code");
        vRecPostedAsmLineBuffer.SetRange(Description, vRecPostedAsmLine.Description);
        vRecPostedAsmLineBuffer.SetRange("Unit of Measure Code", vRecPostedAsmLine."Unit of Measure Code");
        if vRecPostedAsmLineBuffer.FindFirst() then begin
            vRecPostedAsmLineBuffer.Quantity += vRecPostedAsmLine.Quantity;
            vRecPostedAsmLineBuffer.Modify();
        end else begin
            Clear(vRecPostedAsmLineBuffer);
            vRecPostedAsmLineBuffer := vRecPostedAsmLine;
            vRecPostedAsmLineBuffer.Insert();
        end;
    end;

    local procedure wlFncFindPostedShipmentDate(var vRecSalesInvLine: Record "Sales Invoice Line"): Date
    var
        wlRecSalesShipmentHeader: Record "Sales Shipment Header";
        wlRecSalesShipmentBuffer2: Record "Sales Shipment Buffer" temporary;
    begin
        //According FindPostedShipmentDate Report 206
        wgShipmentLineNextEntryNo := 1;
        if vRecSalesInvLine."Shipment No." <> '' then
            if wlRecSalesShipmentHeader.Get(vRecSalesInvLine."Shipment No.") then
                exit(wlRecSalesShipmentHeader."Posting Date");

        if InvHdr."Order No." = '' then
            exit(InvHdr."Posting Date");

        case vRecSalesInvLine.Type of
            vRecSalesInvLine.Type::Item:
                wlFncGenerateBufferFromValueEntry(vRecSalesInvLine);
            vRecSalesInvLine.Type::"G/L Account", vRecSalesInvLine.Type::Resource,
          vRecSalesInvLine.Type::"Charge (Item)", vRecSalesInvLine.Type::"Fixed Asset":
                wlFncGenerateBufferFromShipment(vRecSalesInvLine);
            vRecSalesInvLine.Type::" ":
                exit(0D);
        end;

        ShipmentBuf.Reset();
        ShipmentBuf.SetRange("Document No.", vRecSalesInvLine."Document No.");
        ShipmentBuf.SetRange("Line No.", vRecSalesInvLine."Line No.");
        if ShipmentBuf.Find('-') then begin
            wlRecSalesShipmentBuffer2 := ShipmentBuf;
            if ShipmentBuf.Next() = 0 then begin
                ShipmentBuf.Get(
                  wlRecSalesShipmentBuffer2."Document No.", wlRecSalesShipmentBuffer2."Line No.", wlRecSalesShipmentBuffer2."Entry No.");
                ShipmentBuf.Delete();
                exit(wlRecSalesShipmentBuffer2."Posting Date");
            end;
            ShipmentBuf.CalcSums(Quantity);
            if ShipmentBuf.Quantity <> vRecSalesInvLine.Quantity then begin
                ShipmentBuf.DeleteAll();
                exit(InvHdr."Posting Date");
            end;
        end else
            exit(InvHdr."Posting Date");
    end;

    local procedure wlFncGenerateBufferFromValueEntry(var vRecSalesInvLine: Record "Sales Invoice Line")
    var
        wlRecItemLedgerEntry: Record "Item Ledger Entry";
        wlRecValueEntry: Record "Value Entry";
        wlQuantity: Decimal;
        wlTotalQuantity: Decimal;
    begin
        //According GenerateBufferFromValueEntry Report 206
        wlTotalQuantity := vRecSalesInvLine."Quantity (Base)";
        wlRecValueEntry.SetCurrentKey("Document No.");
        wlRecValueEntry.SetRange("Document No.", vRecSalesInvLine."Document No.");
        wlRecValueEntry.SetRange("Posting Date", InvHdr."Posting Date");
        wlRecValueEntry.SetRange("Item Charge No.", '');
        wlRecValueEntry.SetFilter("Entry No.", '%1..', wgFirstValueEntryNo);
        if wlRecValueEntry.Find('-') then
            repeat
                if wlRecItemLedgerEntry.Get(wlRecValueEntry."Item Ledger Entry No.") then begin
                    if vRecSalesInvLine."Qty. per Unit of Measure" <> 0 then
                        wlQuantity := wlRecValueEntry."Invoiced Quantity" / vRecSalesInvLine."Qty. per Unit of Measure"
                    else
                        wlQuantity := wlRecValueEntry."Invoiced Quantity";
                    wlFncAddBufferEntry(
                      vRecSalesInvLine,
                      -wlQuantity,
                      wlRecItemLedgerEntry."Posting Date");
                    wlTotalQuantity += wlRecValueEntry."Invoiced Quantity";
                end;
                wgFirstValueEntryNo := wlRecValueEntry."Entry No." + 1;
            until (wlRecValueEntry.Next() = 0) or (wlTotalQuantity = 0);
    end;

    local procedure wlFncGenerateBufferFromShipment(pRecSalesInvLine: Record "Sales Invoice Line")
    var
        wlRecSalesShipmentHeader: Record "Sales Shipment Header";
        wlRecSalesShipmentLine: Record "Sales Shipment Line";
        wlRecSalesInvHeader: Record "Sales Invoice Header";
        wlRecSalesInvLine2: Record "Sales Invoice Line";
        wlQuantity: Decimal;
        wlTotalQuantity: Decimal;
    begin
        //According GenerateBufferFromShipment Report 206
        wlTotalQuantity := 0;
        wlRecSalesInvHeader.SetCurrentKey("Order No.");
        wlRecSalesInvHeader.SetFilter("No.", '..%1', InvHdr."No.");
        wlRecSalesInvHeader.SetRange("Order No.", InvHdr."Order No.");
        if wlRecSalesInvHeader.Find('-') then
            repeat
                wlRecSalesInvLine2.SetRange("Document No.", wlRecSalesInvHeader."No.");
                wlRecSalesInvLine2.SetRange("Line No.", pRecSalesInvLine."Line No.");
                wlRecSalesInvLine2.SetRange(Type, pRecSalesInvLine.Type);
                wlRecSalesInvLine2.SetRange("No.", pRecSalesInvLine."No.");
                wlRecSalesInvLine2.SetRange("Unit of Measure Code", pRecSalesInvLine."Unit of Measure Code");
                if wlRecSalesInvLine2.Find('-') then
                    repeat
                        wlTotalQuantity := wlTotalQuantity + wlRecSalesInvLine2.Quantity;
                    until wlRecSalesInvLine2.Next() = 0;
            until wlRecSalesInvHeader.Next() = 0;

        wlRecSalesShipmentLine.SetCurrentKey("Order No.", "Order Line No.");
        wlRecSalesShipmentLine.SetRange("Order No.", InvHdr."Order No.");
        wlRecSalesShipmentLine.SetRange("Order Line No.", pRecSalesInvLine."Line No.");
        wlRecSalesShipmentLine.SetRange("Line No.", pRecSalesInvLine."Line No.");
        wlRecSalesShipmentLine.SetRange(Type, pRecSalesInvLine.Type);
        wlRecSalesShipmentLine.SetRange("No.", pRecSalesInvLine."No.");
        wlRecSalesShipmentLine.SetRange("Unit of Measure Code", pRecSalesInvLine."Unit of Measure Code");
        wlRecSalesShipmentLine.SetFilter(Quantity, '<>%1', 0);

        if wlRecSalesShipmentLine.Find('-') then
            repeat
                if InvHdr."Get Shipment Used" then
                    wlFncCorrectShipment(wlRecSalesShipmentLine);
                if Abs(wlRecSalesShipmentLine.Quantity) <= Abs(wlTotalQuantity - pRecSalesInvLine.Quantity) then
                    wlTotalQuantity := wlTotalQuantity - wlRecSalesShipmentLine.Quantity
                else begin
                    if Abs(wlRecSalesShipmentLine.Quantity) > Abs(wlTotalQuantity) then
                        wlRecSalesShipmentLine.Quantity := wlTotalQuantity;
                    wlQuantity :=
                      wlRecSalesShipmentLine.Quantity - (wlTotalQuantity - pRecSalesInvLine.Quantity);

                    wlTotalQuantity := wlTotalQuantity - wlRecSalesShipmentLine.Quantity;
                    pRecSalesInvLine.Quantity := pRecSalesInvLine.Quantity - wlQuantity;

                    if wlRecSalesShipmentHeader.Get(wlRecSalesShipmentLine."Document No.") then
                        wlFncAddBufferEntry(
                          pRecSalesInvLine,
                          wlQuantity,
                          wlRecSalesShipmentHeader."Posting Date");
                end;
            until (wlRecSalesShipmentLine.Next() = 0) or (wlTotalQuantity = 0);
    end;

    local procedure wlFncCorrectShipment(var vRecSalesShipmentLine: Record "Sales Shipment Line")
    var
        wlRecSalesInvLine: Record "Sales Invoice Line";
    begin
        //According CorrectShipment Report 206
        wlRecSalesInvLine.SetCurrentKey("Shipment No.", "Shipment Line No.");
        wlRecSalesInvLine.SetRange("Shipment No.", vRecSalesShipmentLine."Document No.");
        wlRecSalesInvLine.SetRange("Shipment Line No.", vRecSalesShipmentLine."Line No.");
        if wlRecSalesInvLine.Find('-') then
            repeat
                vRecSalesShipmentLine.Quantity := vRecSalesShipmentLine.Quantity - wlRecSalesInvLine.Quantity;
            until wlRecSalesInvLine.Next() = 0;
    end;

    procedure wlFncAddBufferEntry(var vRecSalesInvLine: Record "Sales Invoice Line"; pQtyOnShipment: Decimal; pPostingDate: Date)
    begin
        //According AddBufferEntry Report 206
        ShipmentBuf.SetRange("Document No.", vRecSalesInvLine."Document No.");
        ShipmentBuf.SetRange("Line No.", vRecSalesInvLine."Line No.");
        ShipmentBuf.SetRange("Posting Date", pPostingDate);
        if ShipmentBuf.Find('-') then begin
            ShipmentBuf.Quantity := ShipmentBuf.Quantity + pQtyOnShipment;
            ShipmentBuf.Modify();
            exit;
        end;

        with ShipmentBuf do begin
            "Document No." := vRecSalesInvLine."Document No.";
            "Line No." := vRecSalesInvLine."Line No.";
            "Entry No." := wgShipmentLineNextEntryNo;
            Type := vRecSalesInvLine.Type;
            "No." := vRecSalesInvLine."No.";
            Quantity := pQtyOnShipment;
            "Posting Date" := pPostingDate;
            Insert();
            wgShipmentLineNextEntryNo += 1;
        end;
    end;

    local procedure wlFncGetLineFeeNoteOnReportHist(pSalesInvNo: Code[20])
    var
        wlRecCust: Record Customer;
        wlRecCustLedgerEntry: Record "Cust. Ledger Entry";
        wlRecLineFeeNoteOnReportHist: Record "Line Fee Note on Report Hist.";
    begin
        LineFee.DeleteAll();
        if not wgDisplayAdditionalFeeNote then
            exit;
        wlRecCustLedgerEntry.SetRange("Document Type", wlRecCustLedgerEntry."Document Type"::Invoice);
        wlRecCustLedgerEntry.SetRange("Document No.", pSalesInvNo);
        if not wlRecCustLedgerEntry.FindFirst() then
            exit;

        if not wlRecCust.Get(wlRecCustLedgerEntry."Customer No.") then
            exit;

        wlRecLineFeeNoteOnReportHist.SetRange("Cust. Ledger Entry No", wlRecCustLedgerEntry."Entry No.");
        wlRecLineFeeNoteOnReportHist.SetRange("Language Code", wlRecCust."Language Code");
        if wlRecLineFeeNoteOnReportHist.FindSet() then
            repeat
                LineFee.Init();
                LineFee.Copy(wlRecLineFeeNoteOnReportHist);
                LineFee.Insert();
            until wlRecLineFeeNoteOnReportHist.Next() = 0
        else begin
            wlRecLineFeeNoteOnReportHist.SetRange("Language Code", wgCduLanguage.GetUserLanguageCode());
            if wlRecLineFeeNoteOnReportHist.FindSet() then
                repeat
                    LineFee.Init();
                    LineFee.Copy(wlRecLineFeeNoteOnReportHist);
                    LineFee.Insert();
                until wlRecLineFeeNoteOnReportHist.Next() = 0;
        end;
    end;

    local procedure wlFncFormatDocumentFields(pRecSalesInvHeader: Record "Sales Invoice Header")
    var
        wlSalesPersonText: Text[50];
        wlCurrencyCode: Code[10];
    begin
        with pRecSalesInvHeader do begin
            wlCurrencyCode := "Currency Code";
            if wlCurrencyCode = '' then begin
                wgRecGLSetup.TestField("LCY Code");
                wlCurrencyCode := wgRecGLSetup."LCY Code";
            end;
            wgTotalText := CopyStr(StrSubstNo(Trl('Total%1'), wlCurrencyCode), 1, 50);
            wgTotalInclVATText := CopyStr(StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode), 1, 50);
            wgTotalExclVATText := CopyStr(StrSubstNo(Trl('Total%1ExclVAT'), wlCurrencyCode), 1, 50);
            wgCduFormatDoc.SetSalesPerson(wgRecSalesPurchPerson, "Salesperson Code", wlSalesPersonText);
            wgCduFormatDoc.SetPaymentTerms(wgRecPaymentTerms, "Payment Terms Code", "Language Code");
            wgCduFormatDoc.SetPaymentMethod(wgRecPaymentMethod, "Payment Method Code", "Language Code");
            wgCduFormatDoc.SetShipmentMethod(wgRecShipmentMethod, "Shipment Method Code", "Language Code");
        end;
    end;

    local procedure wlFncFormatAddressFields(var vRecSalesInvHeader: Record "Sales Invoice Header")
    var
        wlRecRespCenter: Record "Responsibility Center";
    begin
        wgCduFormatAddr.GetCompanyAddr(vRecSalesInvHeader."Responsibility Center", wlRecRespCenter, wgRecCompanyInfo, wgCompanyAddr);
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";
        wgCduFormatAddr.SalesInvBillTo(wgCustAddr, vRecSalesInvHeader);
        wgShowShippingAddr := wgCduFormatAddr.SalesInvShipTo(wgShipToAddr, wgCustAddr, vRecSalesInvHeader);
    end;
}
