report 72110 ReminderDCR
{
    Caption = 'Reminder';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(ReminderHdr; "Issued Reminder Header")
        {
            CalcFields = "Remaining Amount", "Interest Amount", "Additional Fee", "VAT Amount";
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.";
            RequestFilterHeading = 'Reminder';

            column(lblAdditionalFee; Trl('AdditionalFee')) { }
            column(lblAddress; Trl('Address')) { }
            column(lblAmountInclVAT; Trl('AmountInclVAT')) { }
            column(lblBankAccNo; Trl('BankAccNo')) { }
            column(lblBankBranchNo; Trl('BankBranchNo')) { }
            column(lblBankName; Trl('BankName')) { }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo')) { }
            column(lblCustomerNo; Trl('CustomerNo')) { }
            column(lblDaysExpired; Trl('DaysExpired')) { }
            column(lblDocumentDate; Trl('DocumentDate')) { }
            column(lblDocumentNo; Trl('DocumentNo')) { }
            column(lblDueDate; Trl('DueDate')) { }
            column(lblEmail; Trl('Email')) { }
            column(lblFaxNo; Trl('FaxNo')) { }
            column(lblFreeText1; Trl('FreeText1')) { }
            column(lblFreeText2; Trl('FreeText2')) { }
            column(lblFreeText3; Trl('FreeText3')) { }
            column(lblFreeText4; Trl('FreeText4')) { }
            column(lblHeaderDimensions; Trl('HeaderDimensions')) { }
            column(lblHomePage; Trl('HomePage')) { }
            column(lblIBAN; Trl('IBAN')) { }
            column(lblInterest; Trl('InterestAmount')) { }
            column(lblNoOfReminders; Trl('NoOfReminders')) { }
            column(lblOriginalAmount; Trl('Original Amount')) { }
            column(lblOpenNotExpired; Trl('OpenNotExpired')) { }
            column(lblPageOf; Trl('Page{0}of{1}')) { }
            column(lblPhoneNo; Trl('PhoneNo')) { }
            column(lblPostingDate; Trl('PostingDate')) { }
            column(lblRemainingAmount; Trl('RemainingAmount')) { }
            column(lblReminderNo; Trl('ReminderNo')) { }
            column(lblReminderTitle; Trl('Reminder')) { }
            column(lblSWIFT; Trl('SWIFT')) { }
            column(lblTotal; Trl('Total')) { }
            column(lblTotalExpired; Trl('TotalExpired')) { }
            column(lblTotalOpen; Trl('TotalOpen')) { }
            column(lblTotalTransFooter; Trl('TotalTransFooter')) { }
            column(lblTotalTransHeader; Trl('TotalTransHeader')) { }
            column(lblVATAmount; Trl('VATAmount')) { }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification')) { }
            column(lblVATBase; Trl('VATBase')) { }
            column(lblVATClause; Trl('VATClause')) { }
            column(lblVATIdentifier; Trl('VATIdentifier')) { }
            column(lblVATPerc; Trl('VATPerc')) { }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo')) { }
            column(lblYourReference; Trl('YourReference')) { }

            column(CompanyAddr1; wgCompanyAddr[1]) { }
            column(CompanyAddr2; wgCompanyAddr[2]) { }
            column(CompanyAddr3; wgCompanyAddr[3]) { }
            column(CompanyAddr4; wgCompanyAddr[4]) { }
            column(CompanyAddr5; wgCompanyAddr[5]) { }
            column(CompanyAddr6; wgCompanyAddr[6]) { }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.") { }
            column(CompanyBankBranchNo; wgRecCompanyInfo."Bank Branch No.") { }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name") { }
            column(CompanyCity; wgRecCompanyInfo.City) { }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail") { }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.") { }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.") { }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page") { }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN) { }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.") { }
            column(CompanyPicture; wgRecCompanyInfo.Picture) { }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.") { }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code") { }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.") { }
            column(CustAddr1; wgCustAddr[1]) { }
            column(CustAddr2; wgCustAddr[2]) { }
            column(CustAddr3; wgCustAddr[3]) { }
            column(CustAddr4; wgCustAddr[4]) { }
            column(CustAddr5; wgCustAddr[5]) { }
            column(CustAddr6; wgCustAddr[6]) { }
            column(CustAddr7; wgCustAddr[7]) { }
            column(CustAddr8; wgCustAddr[8]) { }
            column(CustomerNo; "Customer No.") { }
            column(DocumentDate; "Document Date") { }
            column(DocumentDateText; Format("Document Date", 0, 4)) { }
            column(DocumentNo; "No.") { }
            column(DueDate; "Due Date") { }
            column(DueDateText; Format("Due Date", 0, 4)) { }
            column(MoveTextLinesToHdrFtr; wgMoveRemTxtLinesToHdrFtr) { }
            column(PostingDate; "Posting Date") { }
            column(PostingDateText; Format("Posting Date", 0, 4)) { }
            column(ShowNotDueAmounts; wgShowNotDueAmounts) { }
            column(TodayText; Format(Today(), 0, 4)) { }
            column(TotalAmountInclVAT; wgTotAmountInclVAT)
            {
                AutoFormatExpression = "Currency Code";
                AutoFormatType = 1;
            }
            column(TotalInclVATText; wgTotalInclVATText) { }
            column(TotalText; wgTotalText) { }
            column(VATRegNo; "VAT Registration No.") { }
            column(YourReference; "Your Reference") { }

            dataitem(HdrComment; "Reminder Comment Line")
            {
                DataItemLink = "No." = Field("No.");
                DataItemLinkReference = ReminderHdr;
                DataItemTableView = sorting(Type, "No.", "Line No.") ORDER(Ascending) where(Type = const("Issued Reminder"));

                column(Comment; Comment) { }
            }
            dataitem(HeaderDim; "Dimension Set Entry")
            {
                DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                DataItemLinkReference = ReminderHdr;
                DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                column(DimText; wgDimText) { }

                trigger OnAfterGetRecord()
                begin
                    wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                end;

                trigger OnPreDataItem()
                begin
                    if not wgShowInternalInfo then
                        CurrReport.Break();
                end;
            }
            dataitem(ReminderTextBegin; "Reminder Text")
            {
                DataItemLink = "Reminder Terms Code" = Field("Reminder Terms Code"), "Reminder Level" = Field("Reminder Level");
                DataItemLinkReference = ReminderHdr;
                DataItemTableView = sorting("Reminder Terms Code", "Reminder Level", Position, "Line No.") where(Position = const(Beginning));

                column(Text; wlFncStrSubstNoText(ReminderTextBegin)) { }
            }
            dataitem(ReminderLine; "Issued Reminder Line")
            {
                DataItemLink = "Reminder No." = Field("No.");
                DataItemLinkReference = ReminderHdr;
                DataItemTableView = sorting("Reminder No.", "Line No.");
                UseTemporary = true;

                column(Amount; Amount)
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(DaysExpired; wgDaysExpired) { }
                column(Description; Description) { }
                column(DocumentDate_2; "Document Date") { }
                column(DocumentNo_2; "Document No.") { }
                column(DueDate_2; "Due Date") { }
                column(LineNo; "Line No.") { }
                column(LineType; "Line Type") { }
                column(LineTypeIx; "Line Type" + 0) { }
                column(NoOfReminders; "No. of Reminders") { }
                column(OriginalAmount; "Original Amount")
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(RemainingAmount_2; "Remaining Amount")
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(Type; Type) { }
                column(TypeIx; Type + 0) { }

                trigger OnAfterGetRecord()
                begin
                    wgDaysExpired := 0;

                    case Type of
                        Type::"G/L Account":
                            begin
                                wgTotAddFee += Amount;
                                "Remaining Amount" := Amount; //In case the line is shown
                            end;
                        Type::"Line Fee":
                            begin
                                wgTotAddFee += Amount;
                                "Remaining Amount" := Amount; //In case the line is shown
                            end;
                        Type::"Customer Ledger Entry":
                            begin
                                wgTotOpen += "Remaining Amount";
                                if "Line Type" = "Line Type"::"Reminder Line" then begin
                                    wgTotExpired += "Remaining Amount";
                                    wgTotInterest += Amount;
                                    if "Due Date" > 0D then
                                        wgDaysExpired := ReminderHdr."Posting Date" - "Due Date"
                                end;
                            end;
                    end;
                end;

                trigger OnPreDataItem()
                begin
                    Reset();
                    wgTotExpired := 0;
                    wgTotInterest := 0;
                    wgTotAddFee := 0;
                    wgTotOpen := 0;
                end;
            }
            dataitem(VATAmtLine; "VAT Amount Line")
            {
                DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                UseTemporary = true;

                column(AmountInclVAT; "Amount Including VAT")
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(VATAmount_2; "VAT Amount")
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(VATBase; "VAT Base")
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(VATIdentifier_2; "VAT Identifier") { }
                column(VATPerc; "VAT %")
                {
                    DecimalPlaces = 0 : 5;
                }

                trigger OnPreDataItem()
                begin
                    if wgTotVATAmount = 0 then
                        CurrReport.Break();

                    Reset();
                end;
            }
            dataitem(VATClause; "VAT Amount Line")
            {
                DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                UseTemporary = true;

                column(Description_4; wgRecVATClause.Description) { }
                column(Description2; wgRecVATClause."Description 2") { }
                column(VATAmount_4; "VAT Amount")
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(VATClauseCode; "VAT Clause Code") { }
                column(VATIdentifier_4; "VAT Identifier") { }

                trigger OnAfterGetRecord()
                begin
                    if "VAT Clause Code" = '' then
                        CurrReport.Skip();
                    if wgRecVATClause.Code <> "VAT Clause Code" then
                        if not wgRecVATClause.Get("VAT Clause Code") then
                            CurrReport.Skip();

                    wgRecVATClause.TranslateDescription(ReminderHdr."Language Code");
                end;

                trigger OnPreDataItem()
                begin
                    Copy(VATAmtLine, true); //Set VATClause to VATAmtLine
                    Reset();
                end;
            }
            dataitem(VATAmtLineLCY; "VAT Amount Line")
            {
                DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                UseTemporary = true;

                column(VALVATBaseLCY; wgVALVATBaseLCY)
                {
                    AutoFormatType = 1;
                }
                column(VALVATAmountLCY; wgVALVATAmountLCY)
                {
                    AutoFormatType = 1;
                }
                column(VATIdentifier_3; "VAT Identifier") { }
                column(VATPerc_2; "VAT %")
                {
                    DecimalPlaces = 0 : 5;
                }

                trigger OnAfterGetRecord()
                begin
                    wgVALVATBaseLCY :=
                      VATAmtLine.GetBaseLCY(
                        ReminderHdr."Posting Date", ReminderHdr."Currency Code", wgCurrencyFactor);
                    wgVALVATAmountLCY :=
                      VATAmtLine.GetAmountLCY(
                        ReminderHdr."Posting Date", ReminderHdr."Currency Code", wgCurrencyFactor);

                    wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                    wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                end;

                trigger OnPreDataItem()
                begin
                    if not wgShowVATLCY then
                        CurrReport.Break();

                    Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                    Reset();
                end;
            }
            dataitem(ReminderTextEnd; "Reminder Text")
            {
                DataItemLink = "Reminder Terms Code" = Field("Reminder Terms Code"), "Reminder Level" = Field("Reminder Level");
                DataItemLinkReference = ReminderHdr;
                DataItemTableView = sorting("Reminder Terms Code", "Reminder Level", Position, "Line No.") where(Position = const(Ending));

                column(Text_2; wlFncStrSubstNoText(ReminderTextEnd)) { }
            }
            dataitem(Total; "Integer")
            {
                DataItemTableView = sorting(Number) where(Number = const(1));

                column(MonolithicVAT; wgMonolithicVAT) { }
                column(NoOfVATAmtLines; wgNoOfVATAmountLines) { }
                column(TotAmount; wgTotAmount)
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(TotAdditionalFee; wgTotAddFee)
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(TotExpired; wgTotExpired)
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(TotInterest; wgTotInterest)
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(TotOpen; wgTotOpen)
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(TotVATAmount; wgTotVATAmount)
                {
                    AutoFormatExpression = ReminderHdr."Currency Code";
                    AutoFormatType = 1;
                }
                column(VATAmtText; wgVATAmountText) { }
                column(TotVALVATBaseLCY; wgTotVALVATBaseLCY) { }
                column(TotVALVATAmountLCY; wgTotVALVATAmountLCY) { }

                trigger OnAfterGetRecord()
                begin
                    wgNoOfVATAmountLines := VATAmtLine.Count();
                    wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                    if wgMonolithicVAT then
                        wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, 30)
                    else
                        wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, 30);
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlRecGLAccount: Record "G/L Account";
                VATPostingSetup: Record "VAT Posting Setup";
                wlCurrencyCode: Code[10];
            begin
                CurrReport.Language := wgCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncGetReminderLevel("Reminder Terms Code", "Reminder Level");

                wgCduFormatAddr.IssuedReminder(wgCustAddr, ReminderHdr);  // NAV2017/NAV2018

                wlCurrencyCode := "Currency Code";
                if wlCurrencyCode = '' then begin
                    wgRecGLSetup.TestField("LCY Code");
                    wlCurrencyCode := wgRecGLSetup."LCY Code";
                end;
                wgTotalText := CopyStr(StrSubstNo(Trl('Total%1'), wlCurrencyCode), 1, 50);
                wgTotalInclVATText := CopyStr(StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode), 1, 50);

                if not CurrReport.Preview() then begin
                    if wgLogInteraction then
                        wgCduSegManagement.LogDocument(
                          8, "No.", 0, 0, Database::Customer, "Customer No.", '', '', "Posting Description", '');
                    IncrNoPrinted();
                end;

                //Get Reminder Lines
                ReminderLine.Reset();
                ReminderLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlFncGetReminderLines(ReminderLine);

                //Get VAT Amount Lines
                wlFncCalcVATAmountLines(ReminderLine, VATAmtLine);
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotAmount := VATAmtLine.GetTotalVATBase();
                wgTotAmountInclVAT := VATAmtLine.GetTotalAmountInclVAT();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                   (ReminderHdr."Currency Code" = '') or
                   (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(ReminderHdr."Posting Date", ReminderHdr."Currency Code", 1);
                    wgVALExchRate := CopyStr(StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount"), 1, 50);
                    wgCurrencyFactor := wgRecCurrExchRate.ExchangeRate(ReminderHdr."Posting Date", ReminderHdr."Currency Code");
                end;

                //Get Additional Fee
                CalcFields("Additional Fee");
                TestField("Customer Posting Group");
                wlFncGetCustPostingGroup("Customer Posting Group");
                if wlRecGLAccount.Get(wgRecCustPostingGroup."Additional Fee Account") then begin
                    wlFncGetVATPostingSetup("VAT Bus. Posting Group", wlRecGLAccount."VAT Prod. Posting Group");
                    wgAdditionalFeeInclVAT := "Additional Fee" * (1 + VATPostingSetup."VAT %" / 100);
                end else
                    wgAdditionalFeeInclVAT := "Additional Fee";

                //Get Interest VAT Percentage
                CalcFields("Interest Amount");
                if "Interest Amount" <> 0 then begin
                    wlRecGLAccount.Get(wgRecCustPostingGroup."Interest Account");
                    wlFncGetVATPostingSetup("VAT Bus. Posting Group", wlRecGLAccount."VAT Prod. Posting Group");
                    wgInterestVATPerc := VATPostingSetup."VAT %";
                end else
                    wgInterestVATPerc := 0;
            end;
        }
    }

    requestpage
    {
        SaveValues = true;

        layout
        {
            area(content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnable;
                    }
                    field(ShowNotDueAmounts; wgShowNotDueAmounts)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Not Due Amounts';
                    }
                    field(MoveRemTxtLinesToHdrFtr; wgMoveRemTxtLinesToHdrFtr)
                    {
                        ApplicationArea = All;
                        Caption = 'Move Reminder Text Lines to Header/Footer';
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnable := true;
        end;

        trigger OnOpenPage()
        begin
            wgLogInteraction := wgCduSegManagement.FindInteractTmplCode(8) <> '';
            wgLogInteractionEnable := wgLogInteraction;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecSalesSetup.Get();

        wgRecCompanyInfo.Get();
        if wgRecSalesSetup."Logo Position on Documents" <> wgRecSalesSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);

        wgCduFormatAddr.Company(wgCompanyAddr, wgRecCompanyInfo);
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecCustPostingGroup: Record "Customer Posting Group";
        wgRecFinChargeTerms: Record "Finance Charge Terms";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecReminderLevel: Record "Reminder Level";
        wgRecSalesSetup: Record "Sales & Receivables Setup";
        wgRecVATClause: Record "VAT Clause";
        wgRecVATPostingSetup: Record "VAT Posting Setup";
        wgCduAutoFormat: Codeunit "Auto Format";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduLanguage: Codeunit Language;
        wgCduSegManagement: Codeunit SegManagement;
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgDimText: Text[120];
        wgTotalInclVATText: Text[50];
        wgTotalText: Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgVATAmountText: Text[30];
        wgAdditionalFeeInclVAT: Decimal;
        wgCurrencyFactor: Decimal;
        wgInterestVATPerc: Decimal;
        wgTotAddFee: Decimal;
        wgTotAmount: Decimal;
        wgTotAmountInclVAT: Decimal;
        wgTotExpired: Decimal;
        wgTotInterest: Decimal;
        wgTotOpen: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgDaysExpired: Integer;
        wgNoOfVATAmountLines: Integer;
        wgReportId: Integer;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnable: Boolean;
        wgMonolithicVAT: Boolean;
        wgMoveRemTxtLinesToHdrFtr: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowNotDueAmounts: Boolean;
        wgShowVATLCY: Boolean;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        if wgReportId = 0 then begin
            Evaluate(wgReportId, DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890')));
            wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        end;
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncGetReminderLines(var vRecIssuedReminderLine: Record "Issued Reminder Line")
    var
        wlRecIssuedReminderLine: Record "Issued Reminder Line";
    begin
        wlRecIssuedReminderLine.SetRange("Reminder No.", ReminderHdr."No.");
        if wlRecIssuedReminderLine.FindSet() then
            repeat
                vRecIssuedReminderLine := wlRecIssuedReminderLine;
                vRecIssuedReminderLine.Insert();
            until wlRecIssuedReminderLine.Next() = 0;
    end;

    procedure wlFncCalcVATAmountLines(var vRecIssuedReminderLine: Record "Issued Reminder Line"; var vRecVATAmountLine: Record "VAT Amount Line")
    begin
        vRecVATAmountLine.DeleteAll();
        with vRecIssuedReminderLine do begin
            Reset();
            if FindSet() then
                repeat
                    vRecVATAmountLine.Init();
                    vRecVATAmountLine."VAT Identifier" := "VAT Identifier";
                    vRecVATAmountLine."VAT Calculation Type" := "VAT Calculation Type";
                    vRecVATAmountLine."Tax Group Code" := "Tax Group Code";
                    vRecVATAmountLine."VAT %" := "VAT %";
                    vRecVATAmountLine."VAT Base" := Amount;
                    vRecVATAmountLine."VAT Amount" := "VAT Amount";
                    vRecVATAmountLine."Amount Including VAT" := Amount + "VAT Amount";
                    vRecVATAmountLine."VAT Clause Code" := "VAT Clause Code";
                    vRecVATAmountLine.InsertLine();
                until Next() = 0;
        end;
    end;

    local procedure wlFncGetReminderLevel(pReminderTermsCode: Code[10]; pReminderLevel: Integer)
    begin
        if (wgRecReminderLevel."Reminder Terms Code" <> pReminderTermsCode) or
           (wgRecReminderLevel."No." <> pReminderLevel)
        then
            wgRecReminderLevel.Get(pReminderTermsCode, pReminderLevel);
    end;

    local procedure wlFncGetCustPostingGroup(pCustPostingGroup: Code[20])
    begin
        if wgRecCustPostingGroup.Code <> pCustPostingGroup then
            wgRecCustPostingGroup.Get(pCustPostingGroup);
    end;

    local procedure wlFncGetVATPostingSetup(pVATBusPostingGroup: Code[20]; pVATProdPostingGroup: Code[20])
    begin
        if (wgRecVATPostingSetup."VAT Bus. Posting Group" <> pVATBusPostingGroup) or
           (wgRecVATPostingSetup."VAT Prod. Posting Group" <> pVATProdPostingGroup)
        then
            wgRecVATPostingSetup.Get(pVATBusPostingGroup, pVATProdPostingGroup);
    end;

    local procedure wlFncStrSubstNoText(var vRecReminderText: Record "Reminder Text"): Text
    var
        wlReminderTotalAmount: Decimal;
    begin
        if ReminderHdr."Fin. Charge Terms Code" <> '' then begin
            if wgRecFinChargeTerms.Code <> ReminderHdr."Fin. Charge Terms Code" then
                if not wgRecFinChargeTerms.Get(ReminderHdr."Fin. Charge Terms Code") then
                    Clear(wgRecFinChargeTerms);
        end else
            Clear(wgRecFinChargeTerms);

        wlReminderTotalAmount :=
          ReminderHdr."Remaining Amount"
          + ReminderHdr."Interest Amount"
          + ReminderHdr."Additional Fee"
          + ReminderHdr."VAT Amount";

        exit(
          StrSubstNo(vRecReminderText.Text,
          ReminderHdr."Document Date",
          ReminderHdr."Due Date",
          wgRecFinChargeTerms."Interest Rate",
          ReminderHdr."Remaining Amount",
          ReminderHdr."Interest Amount",
          ReminderHdr."Additional Fee",
          Format(wlReminderTotalAmount, 0, wgCduAutoFormat.ResolveAutoFormat("Auto Format"::AmountFormat, ReminderHdr."Currency Code")),
          ReminderHdr."Reminder Level",
          ReminderHdr."Currency Code",
          ReminderHdr."Posting Date",
          wgRecCompanyInfo.Name));
    end;
}
